Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 2231)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 2232)
@@ -1466,148 +1891,91 @@
 !-- Go through all points of the subdomain one by one and look for the closest
 !-- surface
-    IF ( TRIM(topography) /= 'flat' )  THEN
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-
-             nzb_si = nzb_s_inner(j,i)
-             vi     = vertical_influence(nzb_si)
-
-             IF ( wall_n(j,i) > 0 )  THEN
-!
-!--             North wall (y distance)
-                DO  k = wall_n(j,i), nzb_si
-                   l_wall(k,j+1,i) = MIN( l_wall(k,j+1,i), 0.5_wp * dy )
-                ENDDO
-!
-!--             Above North wall (yz distance)
-                DO  k = nzb_si + 1, nzb_si + vi
-                   l_wall(k,j+1,i) = MIN( l_wall(k,j+1,i),                     &
-                                          SQRT( 0.25_wp * dy**2 +              &
-                                          ( zu(k) - zw(nzb_si) )**2 ) )
-                ENDDO
-!
-!--             Northleft corner (xy distance)
-                IF ( corner_nl(j,i) > 0 )  THEN
-                   DO  k = corner_nl(j,i), nzb_si
-                      l_wall(k,j+1,i-1) = MIN( l_wall(k,j+1,i-1), &
-                                               0.5_wp * SQRT( dx**2 + dy**2 ) )
-                   ENDDO
-!
-!--                Above Northleft corner (xyz distance)
-                   DO  k = nzb_si + 1, nzb_si + vi
-                      l_wall(k,j+1,i-1) = MIN( l_wall(k,j+1,i-1),              &
-                                            SQRT( 0.25_wp * (dx**2 + dy**2) +  &
-                                            ( zu(k) - zw(nzb_si) )**2 ) )
-                   ENDDO
-                ENDIF
-!
-!--             Northright corner (xy distance)
-                IF ( corner_nr(j,i) > 0 )  THEN
-                   DO  k = corner_nr(j,i), nzb_si
-                       l_wall(k,j+1,i+1) = MIN( l_wall(k,j+1,i+1),             &
-                                                0.5_wp * SQRT( dx**2 + dy**2 ) )
-                   ENDDO
-!
-!--                Above northright corner (xyz distance)
-                   DO  k = nzb_si + 1, nzb_si + vi
-                      l_wall(k,j+1,i+1) = MIN( l_wall(k,j+1,i+1),              &
-                                            SQRT( 0.25_wp * (dx**2 + dy**2) +  &
-                                            ( zu(k) - zw(nzb_si) )**2 ) )
-                   ENDDO
-                ENDIF
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+!
+!--          Check if current gridpoint belongs to the atmosphere
+             IF ( BTEST( wall_flags_0(k,j,i), 0 ) )  THEN
+!
+!--             Check for neighbouring grid-points.
+!--             Vertical distance, down
+                IF ( .NOT. BTEST( wall_flags_0(k-1,j,i), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_grid(k), zu(k) - zw(k-1) )
+!
+!--             Vertical distance, up
+                IF ( .NOT. BTEST( wall_flags_0(k+1,j,i), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_grid(k), zw(k) - zu(k) )
+!
+!--             y-distance
+                IF ( .NOT. BTEST( wall_flags_0(k,j-1,i), 0 )  .OR.             &
+                     .NOT. BTEST( wall_flags_0(k,j+1,i), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dy )
+!
+!--             x-distance
+                IF ( .NOT. BTEST( wall_flags_0(k,j,i-1), 0 )  .OR.             &
+                     .NOT. BTEST( wall_flags_0(k,j,i+1), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dx )
+!
+!--              yz-distance (vertical edges, down)
+                 IF ( .NOT. BTEST( wall_flags_0(k-1,j-1,i), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k-1,j+1,i), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dy**2 +                &
+                                       ( zu(k) - zw(k-1) )**2 ) )
+!
+!--              yz-distance (vertical edges, up)
+                 IF ( .NOT. BTEST( wall_flags_0(k+1,j-1,i), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k+1,j+1,i), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dy**2 +                &
+                                       ( zw(k) - zu(k) )**2 ) )
+!
+!--              xz-distance (vertical edges, down)
+                 IF ( .NOT. BTEST( wall_flags_0(k-1,j,i-1), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k-1,j,i+1), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dx**2 +                &
+                                       ( zu(k) - zw(k-1) )**2 ) )
+!
+!--              xz-distance (vertical edges, up)
+                 IF ( .NOT. BTEST( wall_flags_0(k+1,j,i-1), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k+1,j,i+1), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dx**2 +                &
+                                       ( zw(k) - zu(k) )**2 ) )
+!
+!--             xy-distance (horizontal edges)
+                IF ( .NOT. BTEST( wall_flags_0(k,j-1,i-1), 0 )  .OR.           &
+                     .NOT. BTEST( wall_flags_0(k,j+1,i-1), 0 )  .OR.           &
+                     .NOT. BTEST( wall_flags_0(k,j-1,i+1), 0 )  .OR.           &
+                     .NOT. BTEST( wall_flags_0(k,j+1,i+1), 0 ) )               &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * ( dx**2 + dy**2 ) ) )
+!
+!--             xyz distance (vertical and horizontal edges, down)
+                IF ( .NOT. BTEST( wall_flags_0(k-1,j-1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k-1,j+1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k-1,j-1,i+1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k-1,j+1,i+1), 0 ) )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * ( dx**2 + dy**2 )      &
+                                              +  ( zu(k) - zw(k-1) )**2  ) )
+!
+!--             xyz distance (vertical and horizontal edges, up)
+                IF ( .NOT. BTEST( wall_flags_0(k+1,j-1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k+1,j+1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k+1,j-1,i+1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k+1,j+1,i+1), 0 ) )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * ( dx**2 + dy**2 )      &
+                                              +  ( zw(k) - zu(k) )**2  ) )
+                  
              ENDIF
-
-             IF ( wall_s(j,i) > 0 )  THEN
-!
-!--             South wall (y distance)
-                DO  k = wall_s(j,i), nzb_si
-                   l_wall(k,j-1,i) = MIN( l_wall(k,j-1,i), 0.5_wp * dy )
-                ENDDO
-!
-!--             Above south wall (yz distance)
-                DO  k = nzb_si + 1, nzb_si + vi
-                   l_wall(k,j-1,i) = MIN( l_wall(k,j-1,i),                     &
-                                          SQRT( 0.25_wp * dy**2 +              &
-                                          ( zu(k) - zw(nzb_si) )**2 ) )
-                ENDDO
-!
-!--             Southleft corner (xy distance)
-                IF ( corner_sl(j,i) > 0 )  THEN
-                   DO  k = corner_sl(j,i), nzb_si
-                      l_wall(k,j-1,i-1) = MIN( l_wall(k,j-1,i-1),              &
-                                               0.5_wp * SQRT( dx**2 + dy**2 ) )
-                   ENDDO
-!
-!--                Above southleft corner (xyz distance)
-                   DO  k = nzb_si + 1, nzb_si + vi
-                      l_wall(k,j-1,i-1) = MIN( l_wall(k,j-1,i-1),              &
-                                            SQRT( 0.25_wp * (dx**2 + dy**2) +  &
-                                            ( zu(k) - zw(nzb_si) )**2 ) )
-                   ENDDO
-                ENDIF
-!
-!--             Southright corner (xy distance)
-                IF ( corner_sr(j,i) > 0 )  THEN
-                   DO  k = corner_sr(j,i), nzb_si
-                      l_wall(k,j-1,i+1) = MIN( l_wall(k,j-1,i+1),              &
-                                               0.5_wp * SQRT( dx**2 + dy**2 ) )
-                   ENDDO
-!
-!--                Above southright corner (xyz distance)
-                   DO  k = nzb_si + 1, nzb_si + vi
-                      l_wall(k,j-1,i+1) = MIN( l_wall(k,j-1,i+1),              &
-                                            SQRT( 0.25_wp * (dx**2 + dy**2) +  &
-                                            ( zu(k) - zw(nzb_si) )**2 ) )
-                   ENDDO
-                ENDIF
-
-             ENDIF
-
-             IF ( wall_l(j,i) > 0 )  THEN
-!
-!--             Left wall (x distance)
-                DO  k = wall_l(j,i), nzb_si
-                   l_wall(k,j,i-1) = MIN( l_wall(k,j,i-1), 0.5_wp * dx )
-                ENDDO
-!
-!--             Above left wall (xz distance)
-                DO  k = nzb_si + 1, nzb_si + vi
-                   l_wall(k,j,i-1) = MIN( l_wall(k,j,i-1),                     &
-                                       SQRT( 0.25_wp * dx**2 +                 &
-                                       ( zu(k) - zw(nzb_si) )**2 ) )
-                ENDDO
-             ENDIF
-
-             IF ( wall_r(j,i) > 0 )  THEN
-!
-!--             Right wall (x distance)
-                DO  k = wall_r(j,i), nzb_si
-                   l_wall(k,j,i+1) = MIN( l_wall(k,j,i+1), 0.5_wp * dx )
-                ENDDO
-!
-!--             Above right wall (xz distance)
-                DO  k = nzb_si + 1, nzb_si + vi
-                   l_wall(k,j,i+1) = MIN( l_wall(k,j,i+1),                     &
-                                          SQRT( 0.25_wp * dx**2 +              &
-                                          ( zu(k) - zw(nzb_si) )**2 ) )
-                ENDDO
-
-             ENDIF
-
           ENDDO
        ENDDO
-
-    ENDIF
-
-!
-!-- Multiplication with wall_adjustment_factor
-    l_wall = wall_adjustment_factor * l_wall
-
+    ENDDO
 !
 !-- Set lateral boundary conditions for l_wall
-    CALL exchange_horiz( l_wall, nbgp )
-
-    DEALLOCATE( corner_nl, corner_nr, corner_sl, corner_sr, nzb_local, &
-                vertical_influence, wall_l, wall_n, wall_r, wall_s )
+    CALL exchange_horiz( l_wall, nbgp )     
 
 
Index: /palm/trunk/SOURCE/interaction_droplets_ptq.f90
===================================================================
--- /palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 2231)
+++ /palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -106,5 +106,5 @@
            
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
            
        USE kinds
@@ -114,14 +114,20 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i !<
-       INTEGER(iwp) ::  j !<
-       INTEGER(iwp) ::  k !<
+       INTEGER(iwp) ::  i    !< running index x direction
+       INTEGER(iwp) ::  j    !< running index y direction 
+       INTEGER(iwp) ::  k    !< running index z direction
 
+       REAL(wp) ::  flag     !< flag to mask topography grid points
  
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                q_p(k,j,i)  = q_p(k,j,i)  - ql_c(k,j,i)
-                pt_p(k,j,i) = pt_p(k,j,i) + l_d_cp * ql_c(k,j,i) * pt_d_t(k)
+             DO  k = nzb+1, nzt
+!
+!--             Predetermine flag to mask topography
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
+                q_p(k,j,i)  = q_p(k,j,i)  - ql_c(k,j,i) * flag
+                pt_p(k,j,i) = pt_p(k,j,i) + l_d_cp * ql_c(k,j,i) * pt_d_t(k)   &
+                                                        * flag
              ENDDO
           ENDDO
@@ -145,5 +151,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_s_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds,                                                              &
@@ -154,12 +160,18 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i !<
-       INTEGER(iwp) ::  j !<
-       INTEGER(iwp) ::  k !<
+       INTEGER(iwp) ::  i    !< running index x direction
+       INTEGER(iwp) ::  j    !< running index y direction 
+       INTEGER(iwp) ::  k    !< running index z direction
+
+       REAL(wp) ::  flag     !< flag to mask topography grid points
 
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
-          q_p(k,j,i)  = q_p(k,j,i)  - ql_c(k,j,i)
-          pt_p(k,j,i) = pt_p(k,j,i) + l_d_cp * ql_c(k,j,i) * pt_d_t(k)
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
+          q_p(k,j,i)  = q_p(k,j,i)  - ql_c(k,j,i) * flag
+          pt_p(k,j,i) = pt_p(k,j,i) + l_d_cp * ql_c(k,j,i) * pt_d_t(k) * flag
        ENDDO
 
